package cc.fascinated.bat.features.logging.command;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import net.dv8tion.jda.api.Permission;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "logs", description = "Edit logging settings", requiredPermissions = Permission.MANAGE_SERVER, category = Category.SERVER)
public class LogsCommand extends BatCommand {
    @Autowired
    public LogsCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(SetSubCommand.class),
                context.getBean(RemoveSubCommand.class),
                context.getBean(ListSubCommand.class)
        );
    }
}
