package cc.fascinated.bat.features.namehistory;

import cc.fascinated.bat.common.Serializable;
import com.google.gson.Gson;
import lombok.Getter;
import lombok.Setter;
import org.bson.Document;

import java.util.Date;

/**
 * @author Fascinated (fascinated7)
 */
@Getter @Setter
public class TrackedName extends Serializable {
    /**
     * The new name of the user
     */
    private String name;

    /**
     * The date the name was changed
     */
    private Date changedDate;

    @Override
    public void load(Document document, Gson gson) {
        this.name = document.getString("name");
        this.changedDate = document.getDate("changedDate");
    }

    @Override
    public Document serialize(Gson gson) {
        Document document = new Document();
        document.put("name", this.name);
        document.put("changedDate", this.changedDate);
        return document;
    }

    @Override
    public void reset() {}
}
