package cc.fascinated.bat.features.scoresaber.profile.user;

import cc.fascinated.bat.common.Serializable;
import com.google.gson.Gson;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.bson.Document;

/**
 * @author Fascinated (fascinated7)
 */
@Setter
@Getter
@NoArgsConstructor
public class ScoreSaberProfile extends Serializable {
    /**
     * The Account ID of the ScoreSaber profile
     */
    private String accountId;

    @Override
    public void reset() {
        this.accountId = null;
    }

    @Override
    public void load(Document document, Gson gson) {
        this.accountId = document.getString("accountId");
    }

    @Override
    public Document serialize(Gson gson) {
        Document document = new Document();
        document.put("accountId", this.accountId);
        return document;
    }
}
